close all
clear all
clc

%% KVADRATNO PROGRAMIRANJE 

% Potrebno je minimiziratu kvadratnu funkciju
% f(x) = (3/2)*x1^2 + x2^2 + 2*x3^2 - x1*x2 + x1*x3 + x2*x3 - x1 - 2*x2 - 3*x3 
% uz ogranicenja 
% x1 + 2*x2 - x3 <= 2.5,
% 2*x1 - x2 + 3*x3 = 1,
% x1, x2, x3 >= 0.

%help quadprog

% Kvadratna funkcija definirana u matricnom obliku,
% f(x) = 0.5*x'*H*x + c'*x 
% pri cemu je H simetricna matrica, tj. H=H'
H = [3 -1 1;-1 2 1;1 1 4];
c = [-1 -2 -3];

% Ogranicenja se definiraju u matricnom obliku
% Aeq*x = beq, Ain*x <= bin, lb <= x <= ub
Aeq = [2 -1 3];
beq = 1;
Ain = [1 2 -1;-eye(3)];
bin =[5/2;zeros(3,1)];
lb = [];
ub = []; 

x0 = [];
opt = optimset('Display', 'iter');
[x_optimalno, f_min] = quadprog(H, c, Ain, bin, Aeq, beq, lb, ub, x0, opt)
