close all
clear all
clc

%% NELINEARNO PROGRAMIRANJE 

% Potrebno je minimiziratu funkciju
% f(x) = exp(x1)*(4*x1^2 + 2*x2^2 + 4*x1*x2 + 2*x2 + 1)
% uz ogranicenja 
% 3/2 + x1*x2 - x1 - x2 <= 0,
% -x1*x2 <= 10

%help fmincon

x0 = [-1;-1]; % pocetni uvjeti
Ain = []; 
bin = []; 
Aeq = []; 
beq = []; 
lb = []; 
ub = [];

opt = optimset('Display', 'iter');

[x_optimalno, f_min] = fmincon(@cost_fun, x0, Ain, bin, Aeq, beq, lb, ub, @my_con)

[x1, x2] = meshgrid(-5:0.1:2, -5:0.1:2);
f = exp(x1).*(4*x1.^2 + 2*x2.^2 + 4*x1.*x2 + 2*x2 + 1);

figure(1)
contour(x1, x2, f, 500), hold on
plot(x_optimalno(1), x_optimalno(2), 'k*', x0(1), x0(2), 'ko')
xlabel('x_1'), ylabel('x_2')

figure(2)
surf(x1, x2, f)
xlabel('x_1'), ylabel('x_2'), zlabel('f(x_1,x_2)')